program doLCA, rclass
	version 11.0
	/* set more off		shall remain off for all commands */

	syntax varlist, 						///   
	    NClass(integer) 					///
		categories(numlist >0 integer) 		///
		[id(varlist)      					///
		 COVariates(varlist)  				///
		 GROUPs(varlist)     				///
		 freq(varlist)  					///
		 clusters(varlist) 					///
		 weight(varlist)  					///
		 NSTARTs(integer 1)  				///
		 maxiter(integer 5000)  			///
		 criterion(real 0.000001)   		///
		 REFerence(integer 0)   			///
		 binary(integer 0)					///
		 COREs(integer 1)				    ///
		 measurement(string)                ///
		 groupnames(string)  				/// 
		 seed(real 0.0) 					///
		 seeddraws(real 0.0) 				///
		 gammastart(numlist >=0)  	 	///
		 rhostart(numlist >=0)     	///
		 gammarestrict(numlist >=0)   	///
		 rhorestrict(numlist >=0)   	///
		 gammaprior(real 0.0) 				///
		 betaprior(real 0.0) 				///
		 rhoprior(real 0.0)  				///
		 nobetatest(string )              ///
		 origweights(string )]                

			
	local nci : word count `varlist'
	gen countmissing = 0
	foreach var in `varlist' {
		replace countmissing = countmissing + 1 if missing(`var')
	}
	drop if countmissing == `nci'
	drop countmissing
	drop if missing(`weight') 
	drop if missing(`clusters') 
	//list in 1/10, display	
	//drop if _n>50
	
	compress
	local ncov=0
	if ( `"`covariates'"' != ""){
		local ncov : word count `covariates'
		foreach var in `covariates' {
			drop if missing(`var')
		}
	}

	//local matsize=`maxiter'+5
	//set matsize `matsize'

 	gen countmissing = 0
	foreach var in `varlist' {
		replace countmissing = countmissing + 1 if missing(`var')
	}
	
	local N=_N
	local bMissing=0
	forvalues j = 1(1)`N' {
		if(countmissing[`j']>0){
			local bMissing=1
		}
	}
	drop countmissing
	//display "bMissing" `bMissing'

	tempname param estimate nParmsEst madvec llvec ll_beta_test delta_2ll p_value beta_test_error ///
	         nrc startGamma restrictGamma startBeta startRho restrictRho   ///
			 iter loglik g2 aic bic caic adjustedbic entropyraw entropy df   ///
			 bConverged overflow bFitStats cat_loglik designeff cat_g2 cat_df nClusters ///
			 smallestClusterSize largestClusterSize bStdErrsAvailable bSingularInfoMatrix noBetaTest origWeights ///
			 gammaMatrix gammaSTDMatrix betaMatrix betaSTDMatrix rhoMatrix rhoSTDMatrix  ///
			 outputseeds outputSeedsloglik outputSeedsGamma percent_loglik ///
			 odds_ratioMatrix lowerCIMatrix upperCIMatrix covbMatrix
			 			 	
	local numCategories : word count `categories'
		
	if(`nci' != `numCategories'){
		display as error "The number of varlist and categories must be equal."
		exit 198
	}


	//tokenize `varlist' 
	local nrcmax=0
	matrix define `nrc' = J(1, `nci', 0.0)
	local i=1
	foreach var in `varlist'{
	//forval i = 1/`nci'{
		local value : word `i' of `categories'
		mat `nrc'[1,`i']=`value'
		if(`value'>`nrcmax') local nrcmax=`value'
		assert int(`var') == `var' if `var' < .
		assert `var' > 0 & `var' <= `value' if `var' < .
		local i=`i'+1
	}	
	
	if ( `nclass' <= 0 ) {
		display as error "nclass must be positive"
		exit 198
	}

	if( `nclass' <= 1 & `ncov' > 1 ){
		display as error "NCLASS must be greater than 1 when COVARIATES is specified."
		exit 198
	}

	if ( `seed' < 0 ) {
		display as error "seed must be positive"
		exit 198
	} 

	if ( `reference'<0 ){
		display as error "reference must be positive"
		exit 198
	} 

	if ( `binary'<0 ){
		display as error "binary must be positive"
		exit 198
	} 

	if ( `"`rhoprior'"' != "0" & `rhoprior' <= 0 ) {
		display as error "rho prior must be positive"
		exit 198
	}
	
	/*if ( `ncov' > 1 & `nstarts' > 1 ) {
		display as error "The NSTARTS option cannot be used together with covariates. "
		display as error "We recommend first finding a good seed value or good starting values"
		display as error " using NSTARTS in the no-covariates case, and then adding covariates."
		exit 198
	}
	
	if ( (`reference' > 0 | `binary' > 0) & `nstarts' > 1 ){
		display as error "NSTARTS may not be specified when Reference/Binary option is specified."
		exit 198
	}*/

	if( `"`betaprior'"' != "0" & `ncov' == 0 ) {
		display as error "betaprior can't be present when COVARIATES is not specified.."
		exit 198
	}

	if( `"`gammaprior'"' != "0" & `ncov' > 1 ){
		display as error "gammaprior can't be present when COVARIATES is specified."
		exit 198
	}

	/*if( `"`betaprior'"' != "0" & `nstarts' > 1 ){
		display as error "NSTARTS may not be specified when betaprior is specified."
		exit 198
	}*/

	if( `"`betaprior'"' != "0" & `ncov' == 0 ){
		display as error "betaprior can't be present when COVARIATES is not specified.."
		exit 198
	}

	local bRhoEqualAcrossStrata=0              /* false */
	if ( `"`measurement'"' == "groups") {
		local bRhoEqualAcrossStrata=1
	}

	local noBetaTest=0
	if ( `"`nobetatest'"' == "yes") {
		local noBetaTest=1
	}
	
	local origWeights=0
	if ( `"`origweights'"' == "yes") {
		local origWeights=1
	}

	if( `bRhoEqualAcrossStrata' >0 & `"`groups'"' == "" ){
		display as error "MEASUREMENT can be specified only when GROUPS is specified."
		exit 198
	}

	if(`ncov' < 1 & `reference' > 0){
		display as error "REFERENCE is only valid when COVARIATES is specified."
		exit 198
	}

	if(`ncov' < 1 & `binary' > 0){
		display as error "BINARY is only valid when COVARIATES is specified."
		exit 198
	}
	
	if(`reference' > 0 & `binary' > 0){
		display as error "BINARY is not valid when REFERENCE is specified."
		exit 198
	}
	
	if( `nstarts' > 1 & `"`gammastart'"' != "" ){
		display as error "NSTARTS should not be used when gammastart is provided."
		exit 198
	}

	if( `"`gammastart'"' != "" & `seed' > 0 ){
		display as error "Using both SEED and START is not valid."
		exit 198
	}
	
	if( int(`seed') == 0 & `"`gammastart'"' == "" ){
		display as error "SEED or START must be specified, SEED must be positive."
		exit 198
	} 
	
    local nstr=1	
	if(`"`groups'"'!=""){
		assert int(`groups')==`groups' if `groups' < .
		assert `groups' > 0 if `groups' < .
		local minGroup=10000
		local maxGroup=0
		forvalues i = 1(1)`N'{
			if(`groups'[`i'] > `maxGroup') local maxGroup=`groups'[`i']
			if(`groups'[`i'] < `minGroup') local minGroup=`groups'[`i']
		}
		local nstr=`maxGroup'-`minGroup'+1
		if(`minGroup' != 1) {
			display as error "Levels in the grouping variable must start with 1"
			exit 198
		}
		if(`maxGroup' != `nstr') {
			display as error "The grouping variable does not have contiguous levels; `nstr' level(s) not found."
			exit 198
		}
		//local group1stvalue: word `0' of `groups'
	}

	if("`groupnames'" != ""){
		if(wordcount("`groupnames'") != `nstr'){
			display as error "The number of group names is not the same as the number of group levels."
			exit 198
		}
		tokenize "`groupnames'"
		//for word of "`groupnames'"
	}

	local bID=0              /* false */
	if ( `"`id'"' != "") {
		local bID=1
	}

	local bAgg=0              /* false */
	if ( `"`freq'"' != "") {
		local bAgg=1
		assert `freq' != . & `freq' > 0
	}
	
	local bWeighted=0              /* false */
	if ( `"`weight'"' != "") {
		local bWeighted=1
		assert `weight' > 0 & `weight' < 1000000000
	}

	local bClustered=0              /* false */
	if ( `"`clusters'"' != "") {
		local bClustered=1
		assert `clusters' > 0
		assert int(`clusters')==`clusters'
	}

	if( `"`measurement'"' == "" & "`groupnames'" != "" & `bClustered' > 0 ){
		display as error "This version of LCA currently requires measurement invariance when the data are clustered."
		exit 198
	}

 	if( `"`gammarestrict'"' != "" & `bClustered' > 0 ){
		display as error "The gammarestrict option cannot be used with the clusters option in the current version of LCA."
		exit 198
	}

	local numGamma : word count `gammastart'
	if(`"`gammastart'"' !="" & `numGamma' != `nstr' * `nclass'){
		display as error "gammastart has wrong total number of values."
		exit 198
	}

	matrix define `startGamma'= J(1, `nstr' * `nclass', 1.0/`nclass')
	if(`"`gammastart'"' !=""){
		forvalues i=1/`numGamma'{
			local value : word `i' of `gammastart'
			mat `startGamma'[1,`i']=`value'
		}
	}

	local numgammarestrict : word count `gammarestrict'
	if( `"`gammarestrict'"' !="" & `numgammarestrict' != `nstr' * `nclass'){
		display as error "gammarestrict has wrong total number of values."
		exit 198
	}

 	matrix define `restrictGamma'= J(1, `nstr' * `nclass', 1.0)
	if(`"`gammarestrict'"' !=""){
		forvalues i=1/`numGamma' {
			local value : word `i' of `gammarestrict'
			mat `restrictGamma'[1,`i']=`value'
		}
	}

	local ncol = (`ncov'+1) * (`nclass' -1)
	if(`binary'>0 | `nclass'<= 1) {
		local ncol = `ncov'+1
	}
	
	matrix define `betaMatrix'= J(`nstr'* (`ncov'+1), `nclass' , 0.0)
	matrix `betaMatrix'[`nstr'* (`ncov'+1),1]=1.0    //work around making matrix asymmetric to get around bug in plugin.
	matrix define `betaSTDMatrix'= J(`nstr'* (`ncov'+1), `nclass', 0.0)
	matrix `betaSTDMatrix'[`nstr'* (`ncov'+1),1]=1.0  //work around making matrix asymmetric to get around bug in plugin.
	matrix define `covbMatrix'=J(`nstr',`ncol' * `ncol',0.0)
	matrix `covbMatrix'[1,`ncol' * `ncol']=1.0
	
	//matlist `betaMatrix'
	//matlist `betaSTDMatrix'
 	matrix define `startBeta'= J(1, `nstr' * `nclass' * (`ncov'+1), 0.0)

	local numRho : word count `rhostart'
	if( `"`rhostart'"' !="" & `numRho' != `nstr' * `nclass' * `nci' * `nrcmax' ){
		display as error "rhostart has wrong total number of values."
		exit 198
	}

 	matrix define `startRho'= J(1, `nstr' * `nclass' * `nci' * `nrcmax', 0.0)
	if(`"`rhostart'"' !=""){
		forvalues i=1/`numRho' {
			local value : word `i' of `rhostart'
			mat `startRho'[1,`i']=`value'
		}
	}
	
	local numrhorestrict : word count `rhorestrict'
	if( `"`rhorestrict'"' !="" & `numrhorestrict' != `nstr' * `nclass' * `nci' * `nrcmax'){
		display as error "rhorestrict has wrong total number of values."
		exit 198
	}
	
 	matrix define `restrictRho'= J(1, `nstr' * `nclass' * `nci' * `nrcmax', 1.0)
	if(`"`rhorestrict'"' !=""){
		forvalues i=1/`numRho' {
			local value : word `i' of `rhorestrict'
			mat `restrictRho'[1,`i']=`value'
		} 
	}

	matrix define `gammaMatrix'=J(`nstr',`nclass',0.0)
	matrix define `gammaSTDMatrix' = J(`nstr',`nclass', 0.0)
	matrix define `nParmsEst'= J(5,1,0)
	
	
  	local rhoRowNames ""  
	forvalues k = 1/`nstr'{
		forvalues j = 1/`nrcmax'{
			forvalues i = 1/`nci'{
				local x: word `i' of `varlist'
				local rhoRowNames `"`rhoRowNames' `x'`j'`k'"'   /*separate by space for all rhoRowNames */
			}
		}
	}
	
	local colNames ""
	forvalues i = 1/`nclass'{
			local str="Class`i'"
			local colNames `"`colNames' `str'"'
	}

	/*local postColNames "`colNames'"
	if(int(`seeddraws') > 0 ){
		local postColNames "`postColNames' bestIndex"
		forvalues i = 1/20 {
				local str="Draw`i'"
				local postColNames `"`postColNames' `str'"'
		}
	} */
	
	if(`"`id'"'!=""){
		local ppRowNames ""  
		forvalues j = 1(1)`N' {
			local str=`id'[`j']
			local ppRowNames `"`ppRowNames' `str'"'
		}
		//display `ppRowNames'
	}

 	local seedRowNames ""  
	forvalues k = 1/`nstarts'{
		local seedRowNames `"`seedRowNames' `k'"' 
	}
	
  	local gammasColNames ""  
	forvalues k = 1/`nstr'{
		forvalues j = 1/`nclass'{
				local gammasColNames `"`gammasColNames' Gamma_`j'_`k'"'
		}
	}

	matrix define `rhoMatrix' = J(`nstr'*`nrcmax'*`nci', `nclass', 0.0)
	matrix `rhoMatrix'[`nstr'*`nrcmax'*`nci',1]=1.0    //work around making matrix asymmetric to get around bug in plugin.
	matrix define `rhoSTDMatrix' = J(`nstr'*`nrcmax'*`nci', `nclass', 0.0)
	matrix `rhoSTDMatrix'[`nstr'*`nrcmax'*`nci',1]=1.0    //work around making matrix asymmetric to get around bug in plugin.

	matrix define `param' = J(21, 1, 0.0)
	mat `param'[1,1]=`nstarts' 
	mat `param'[2,1]=`nci' 
	mat `param'[3,1]=`ncov' 
	mat `param'[4,1]=`nstr' 
	mat `param'[5,1]=`bAgg' 
	mat `param'[6,1]=`bWeighted' 
	mat `param'[7,1]=`bClustered' 
	mat `param'[8,1]=`bRhoEqualAcrossStrata' 
	mat `param'[9,1]=`nclass'
	mat `param'[10,1]=`nrcmax' 
	mat `param'[11,1]=`reference' 
	mat `param'[12,1]=`binary' 
	mat `param'[13,1]=int(`seed')
	mat `param'[14,1]=`gammaprior'
	mat `param'[15,1]=`betaprior'
	mat `param'[16,1]=`rhoprior'
	mat `param'[17,1]=`maxiter' 
	mat `param'[18,1]=`criterion' 
	mat `param'[19,1]=`noBetaTest' 
	mat `param'[20,1]=`origWeights' 
	mat `param'[21,1]=int(`seeddraws') 
	
	matrix define `estimate' = J(23, 1, 0.0)
	
	matrix define `outputseeds' = J(`nstarts', 1, 0.0)
	matrix define `outputSeedsloglik' = J(`nstarts', 1, 0.0)
	matrix define `outputSeedsGamma' = J(`nstarts',`nstr'*`nclass', 0.0)
	matrix `outputSeedsGamma'[`nstarts',1]=1.0    //work around making matrix asymmetric to get around bug in plugin.
	
	//matrix define `madvec'= J(`maxiter', 1, 0.0)
	//matrix define `llvec'= J(`maxiter', 1, 0.0)	
	if(`ncov'>0){
		matrix define `ll_beta_test'= J(`ncov', 1, 0.0)
		matrix define `delta_2ll'= J(`ncov', 1, 0.0)
		matrix define `p_value'= J(`ncov', 1, 0.0)
		matrix define `beta_test_error'= J(`ncov', 1, 0.0)
	}
	//set trace on
 	/*matrix list `nrc'
 	matrix list `startGamma'
	matrix list `restrictGamma'
	matrix list `startBeta'
	matrix list `startRho'
	matrix list `restrictRho' */

   /* everything is list includes `varlist', covariates, groups, id, freq, clusters and weight  */
 	plugin call lca `varlist' `covariates' `groups' `freq' `weight' `clusters' , `param' `nrc' ///
					`startGamma' `restrictGamma' `startBeta' `startRho' `restrictRho' ///
					`estimate' `gammaMatrix' `gammaSTDMatrix' ///
					`betaMatrix' `betaSTDMatrix' `rhoMatrix' `rhoSTDMatrix' ///
					`outputseeds' `outputSeedsloglik' `outputSeedsGamma' `nParmsEst'  ///
					`ll_beta_test' `delta_2ll' `p_value' `beta_test_error' `covbMatrix' ///
					
					
	local iter=`estimate'[1,1]
	local loglik=`estimate'[2,1]
	local g2=`estimate'[3,1]
	local aic=`estimate'[4,1]
	local bic=`estimate'[5,1]
	local caic=`estimate'[6,1]
	local adjustedbic=`estimate'[7,1]
	local entropyraw=`estimate'[8,1]
	local entropy=`estimate'[9,1]
	local df=`estimate'[10,1]
	local bConverged=`estimate'[11,1]
	local overflow=`estimate'[12,1]
	local bFitStats=`estimate'[13,1]
	local designeff=`estimate'[14,1]
	local cat_loglik=`estimate'[15,1]
	local cat_g2=`estimate'[16,1]
	local cat_df=`estimate'[17,1]
	local nClusters=`estimate'[18,1]
	local smallestClusterSize=`estimate'[19,1]
	local largestClusterSize=`estimate'[20,1]
	local percent_loglik=`estimate'[21,1]
	local bStdErrsAvailable=`estimate'[22,1]
	local bSingularInfoMatrix=`estimate'[23,1]
		
	matrix colnames `gammaMatrix' = `colNames'   
	matrix colnames `gammaSTDMatrix' = `colNames' 
	matrix colnames `rhoMatrix' = `colNames' 
	matrix rownames `rhoMatrix' = `rhoRowNames'
	matrix colnames `rhoSTDMatrix' = `colNames' 
	matrix rownames `rhoSTDMatrix' = `rhoRowNames' 
	

	matrix rownames `outputseeds' = `seedRowNames' 
	matrix colnames `outputseeds' = "seed"
	matrix rownames `outputSeedsloglik' = `seedRowNames'
	matrix colnames `outputSeedsloglik' = "loglik"
	matrix rownames `outputSeedsGamma' = `seedRowNames' 
	matrix colnames `outputSeedsGamma' = `gammasColNames' 
	
	if(`ncov'>0){
		display "Data and Model Summary and Fit Statistics (EM Algorithm with Logistic Regression)"
	}
	else {
		display "Data Summary, Model Information, and Fit Statistics (EM Algorithm)"
	}
	display "Number of subjects in analysis: = " `N'
	if(`bClustered'>0){
		display "Number of clusters in analysis: " `nClusters'
		display "Smallest cluster size: " `smallestClusterSize'
		display "Largest cluster size: " `largestClusterSize'
	}
	display "Number of measurement items: " `nci'
	display "Number of groups in the data: " `nstr'
	display "Number of latent classes: " `nclass'
	if(`ncov'>0){
		if(`binary'>0){
			display "Logistic model: binary"
			display "Number of covariates used: " `ncov'
			display "Comparison class: " `binary'
		}
		else{
			display "Logistic model: multinomial"
			display "Number of covariates used: " `ncov'
			if( `reference' > 0 ) {
				display "Reference class: " `reference'
			}
			else {
				display "Reference class: 1" 
			}
		}
	}
	if(`gammaprior'>0.0){
		display "A data-derived prior was applied to the gamma parameters."
	}
	
	if(`betaprior'>0.0){
		display "NOTE: A data-derived prior was applied to the beta parameters to stabilize the logistic regression model."
	}
	
	if(`rhoprior'>0.0){
		display "NOTE: A data-derived prior was applied to the rho parameters to help avoid parameter estimates on boundary values of zero and one."
	}
	
	
	if(`bWeighted'>0){
		display "The analysis includes sampling weights. Weighting variable name: " "`weight'"
	}
	if(`bClustered'>0){
		display "The analysis includes clusters. Cluster variable name: " "`clusters'"
	}
	
	if(`seed'>0){
		display "Rho starting values were randomly generated (seed = `seed')."
	}
	else{
		display "Starting values were provided via numlist option."
	}
	
	if(`bRhoEqualAcrossStrata'>0){
		display "Rho (measurement) parameters were constrained to be equal across groups."
	}
	
	if(`nstarts'>1){
		display "Seed selected for best fitted model: " %13.4f `outputseeds'[1,1]
		display "Percentage of seeds associated with best fitted model: " `percent_loglik' "%"
	}
	
	
	if(`bConverged'>0){
		display "The model converged in " `iter' " iterations." 
	}
	else{
		display "The model did not converge." 
	}
	display "Log-likelihood = " `loglik'
	if(`bWeighted'>0){
		display "(Based on the pseudo-likelihood incorporating weights)"
	}
	else if(`bClustered'>0){
		display "(Based on the pseudo-likelihood)"
	}
	if(`bFitStats'>0){
		display "G-squared = " `g2'
		display "AIC = " `aic'
		display "BIC = " `bic'
		display "CAIC = " `caic'
		display "Adjusted BIC = " `adjustedbic'
		display "Entropy Raw = " `entropyraw'
		display "Entropy R-sqd = " `entropy'
		if(`designeff' > 0) {
			display "DESIGNEFFECT = " `designeff'
		}
		display "Degrees of freedom = " floor(`df'+0.5)
		
		if(`bMissing'>0 & `bClustered' <1 & `bWeighted'<1 ){
			display "Test for MCAR"
			display "Log-likelihood= " `cat_loglik'
			display "G-squared= " `cat_g2'
			if(int(`overflow') == 0) {
				display "Degrees of freedom= " floor(`cat_df'+0.5)
			}
		}
		display "Number of gamma parameters estimated:" `nParmsEst'[3,1]
		display "Number of rho parameters estimated::" `nParmsEst'[1,1]
	}

	/*matrix list `gammaMatrix'
	matrix list `gammaSTDMatrix'
	matrix list `rhoMatrix'
	matrix list `rhoSTDMatrix'
	matrix list `outputseeds'
	matrix list `outputSeedsloglik'
	matrix list `outputSeedsGamma'*/
	
	return scalar iteration = floor(`iter'+0.5)
	return scalar loglikelihood = `loglik'
	if(`bFitStats'>0){
		return scalar Gsquared = `g2'
		return scalar aic = `aic'
		return scalar bic = `bic'
		return scalar caic = `caic'
		return scalar AdjustedBIC = `adjustedbic'
		return scalar EntropyRaw = `entropyraw'
		return scalar EntropyRsqd = `entropy'
	}
	return scalar df = floor(`df'+0.5)
	if(`designeff' > 0) {
		return scalar designeffect = `designeff'
	}
	matrix g=`gammaMatrix'
	return matrix gamma `gammaMatrix'
	if(`bStdErrsAvailable'>0){
		return matrix gammaSTD `gammaSTDMatrix'
	}
	if(`ncov'>0){
		matrix define `odds_ratioMatrix'= J(`nstr'* (`ncov'+1), `nclass', 0.0)
		matrix define `lowerCIMatrix'= J(`nstr'* (`ncov'+1), `nclass', 0.0)
		matrix define `upperCIMatrix'= J(`nstr'* (`ncov'+1), `nclass', 0.0)
		local rowCount=`nstr'* (`ncov'+1)
		forvalues i=1/`rowCount' {
			if(`bStdErrsAvailable'>0) {
				if(`binary'>0){ 
					mat `betaSTDMatrix'[`i',`binary'] = 0
				}
				else if(`reference' >0){
					mat `betaSTDMatrix'[`i',`reference'] = 0
				}
			}
			forvalues j=1/`nclass' {
				mat `odds_ratioMatrix'[`i',`j']=exp(`betaMatrix'[`i',`j'])
				if(`bStdErrsAvailable'>0){
					mat `lowerCIMatrix'[`i',`j']=exp(`betaMatrix'[`i',`j']-1.96*`betaSTDMatrix'[`i',`j'])
					if(`betaMatrix'[`i',`j']+1.96*`betaSTDMatrix'[`i',`j']<log(1000000)){
						mat `upperCIMatrix'[`i',`j']=exp(`betaMatrix'[`i',`j']+1.96*`betaSTDMatrix'[`i',`j'])
					}
				}
			}
		}
		local diverge=0
		local df=0
		display "Beta parameter test (Type III):  (based on 2*log-likelihood)"
		local warning=0
		local i=1
		foreach var in `covariates'{
				if(`delta_2ll'[`i',1]<0){
					local warning=1
				}
			local i=`i'+1
		}
		if(int(`warning') == 1){
			display "	WARNING: The log likelihood test statistic for one or more covariates was negative."
			display "	Try a different start value and/or fewer covariates."
		}
		else {
			local i=1
			foreach var in `covariates'{
				if(int(`beta_test_error'[`i',1]) == 1){
					display "`var'" " (An error occurred during estimation.)"
				}
				else {
					if(int(`beta_test_error'[`i',1]) == 2){
						local diverge=1
					}
					if(`binary' > 0){
						local df=`nstr'
					}
					else{
						local df=(`nclass'-1)*`nstr'
						if ( `"`gammarestrict'"' !="" ) {
							local  maxRestGamma=0;
							forvalues j=1/`nstr' {
								forvalues k=1/`nclass' {
									if(`restrictGamma'[1,(`j'-1)*`nclass' +`k']>`maxRestGamma'){
										local maxRestGamma=`restrictGamma'[1,(`j'-1)*`nclass' +`k']
									}
								}
							}
							forvalues j=1/(`maxRestGamma'+1) {
								if(`j'==2) local j = `j'+1 
								local restValueFreq=0
								forvalues n=1/`nstr'{
									forvalues k=1/`nclass' {
										if(int(`restrictGamma'[1,(`n'-1)*`nclass' +`k'])==`j'){
											local restValueFreq=`restValueFreq'+1
										}
									}
											
								 }
								 if(`j' == 1){
									 local df = `df' - `restValueFreq'
								 }
								 else if(`j'>2 && `restValueFreq'>1 ){
									 local df=`df'-(`restValueFreq'-1)
								 }
							}
						}
					}
					if(`delta_2ll'[`i',1]>0){
						if(int(`diverge')==1) {
							display "For *" "`var'" " :"
						}
						else {
							display "For " "`var'" " :"
						}
						display "Exclusion LL = " `ll_beta_test'[`i',1] 
						display "Change in 2*L = " `delta_2ll'[`i',1]
						display "deg freedom = " `df'
						display "p-Value = " `p_value'[`i',1]
					}
				}
				if( int(`diverge')==1 ) {
					display "	(* indicates that estimation did not converge. P-value for this covariate may be unreliable. )"
				}
				local i=`i'+1
			}
		}
		matrix b=`betaMatrix'
		return matrix beta `betaMatrix'
		return matrix odds_ratio `odds_ratioMatrix'
		return matrix covb `covbMatrix'
		if(`bStdErrsAvailable'>0){
			return matrix betaSTD `betaSTDMatrix'
			return matrix lower_CI `lowerCIMatrix'
			return matrix upper_CI `upperCIMatrix'
		}
		return matrix beta_test_error `beta_test_error'
		return matrix ll_beta_test `ll_beta_test'
		return matrix delta_2ll `delta_2ll'
		return matrix p_value `p_value'
	}
	matrix r=`rhoMatrix'
	return matrix rho `rhoMatrix'
	if(`bStdErrsAvailable'>0){
		return matrix rhoSTD `rhoSTDMatrix'
	}
	//return matrix madvec `madvec'
	//return matrix llvec `llvec'
	
	if(`nstarts'>1){
		return matrix seeds `outputseeds'
		return matrix logliks `outputSeedsloglik'
		return matrix gammas `outputSeedsGamma'
	}
	
tempname max den const d gammaIndexIncByGroup betaIndexIncByGroup rhoIndexIncByGroup
*calculate case-wise class membership 
gen `gammaIndexIncByGroup' = 0
replace `gammaIndexIncByGroup' = `groups'-1 if (`"`groups'"'!="")
if ( `"`covariates'"' != "") { 
gen `const'=1
gen `d'=0
gen `betaIndexIncByGroup'= 0
replace `betaIndexIncByGroup'= (`groups'-1)*(`ncov'+1) if (`"`groups'"'!="")
forvalues c=1/`nclass'  { 
	tempname pcm`c'
	qui gen `pcm`c''=1
	local j=1
	foreach var in `const' `covariates' {
		qui replace `pcm`c''=`pcm`c''*exp(`var'*b[`j'+`betaIndexIncByGroup',`c'])
		local j=`j'+1
		}
qui replace `d'=`d'+`pcm`c''
						}
forvalues c=1/`nclass'  { 
cap drop _ppcm`c'
	qui gen _ppcm`c'=`pcm`c''/`d'
						}
							}
if ( `"`covariates'"' == "") {
	forvalues c=1/`nclass'  { 
		cap drop _ppcm`c'
		qui gen double _ppcm`c'=g[1+`gammaIndexIncByGroup',`c']
							}
							}
						
*	
*genereting posterior probabilties*
gen double `den'=0
if ( `"`measurement'"' == "groups" || `"`groups'"' == "" ) {
	gen `rhoIndexIncByGroup'= 0
}
else {
	gen `rhoIndexIncByGroup' = (`groups'-1)*`nrcmax'*`nci'
}

forvalues c=1/`nclass'  {
	tempname pr`c'
	if ( `"`covariates'"' == " ") {
		qui gen double `pr`c''=g[1+`gammaIndexIncByGroup',`c']
				}
	if ( `"`covariates'"' != " ") {
		qui gen double `pr`c''=_ppcm`c'
		}
	local j=1 
	forvalues n=1/`nrcmax' {
		foreach var in `varlist' {
		qui replace `pr`c''=`pr`c''*(r[`j'+`rhoIndexIncByGroup',`c']^(`var'==`n'))
		local j=`j'+1
}
}
	replace `den'=`den'+`pr`c''
}


forvalues c=1/`nclass'  { 
	cap drop _post_prob`c'
	qui gen double _post_prob`c'=`pr`c''/`den'
				}
				
*get the best-class indicator
qui egen double `max'=rowmax(_post_prob*)
cap drop _Best_Index
qui gen  _Best_Index=1 if  _post_prob1==`max'
forvalues c=2/`nclass'  {
qui replace _Best_Index=`c' if  _post_prob`c'==`max' & _Best_Index==.
}


*Generate random draws from post-cls if seeddraws option is provided*
local N=_N
if(int(`seeddraws') > 0 ){
	set seed `seeddraws'
	forvalues n=1/20 { 
		cap drop _draw`n'
		gen double u  = uniform()
		gen double _draw`n' = 1
		local nc=`nclass'-1
		forvalues j = 1(1)`N' {
			local low = 0.0
			local upper = _post_prob1[`j']
			forvalues c=1/ `nc'{
			   if( u[`j'] > `upper') {
				   local low = `low' + _post_prob`c'[`j']
				   local iu=`c'+1
				   local upper = `upper' + _post_prob`iu'[`j']
				   qui replace _draw`n' = `c'+1 if( u[`j'] > `low' & u[`j'] <= `upper') in `j'
			   }
			}
		}
		cap drop u 
	}
}
	
end 
program lca, plugin using("D:\project\Stata_lca\LCA_Distal_BCH_64-bit\lca.dll")

